;Thanks to Kevin Kofler for him being so understandable and helping me so much! And also for
;correcting my orthography!
	include	"os.h"		;for ROM_CALLs
	xdef		_main		;_main
	xdef		_nostub	;SDK gives programs that run without any shell
	xdef		_ti89		;for the TI89
	xdef		_ti92plus	;and th TI92+



;*****************************************************

_main:

	move.l		#TSR_End-TSR_Start,d0	;Size of program
	move.l		d0,-(a7)
	ROM_CALL	HeapAllocHigh			;Gets some bytes free to copy the program High
	move.l		(a7)+,d7			;d7 = size of the program
	tst.w		d0				;d0 = allocated handle
	beq		MemoryError			;d0 = 0 => not enough memory

	move.w		d0,-(a7)
	ROM_CALL	HeapLock			;Locks the handle
	ROM_CALL	HeapDeref			;Gets the position of the futur program in a0
	lea		2(a7),a7
	move.l		a0,a1				;We have to copy ( a1 ) and to save ( a0 )
	lea		TSR_Start(pc),a2		;Gets the beginning of the program

	subq.w		#1,d7				;dbra stops when d7 = -1
LoopCopyTsr:
	move.b		(a2)+,(a1)+			;Copy
	dbf		d7,LoopCopyTsr		;Loop

	add.l		#$40000,a0			;Add $40000 for TI HWD2 Calculators (Thx to Kevin Kofler)
	bclr.b		#2,$600001			;Enables writting under $100
	move.l		$2C,Old1111			;Gets the old routine address
	move.l		a0,$2C				;Puts the new routine address
	bset.b		#2,$600001			;Disables writting under $100
	pea		Succes(pc)
	dc.w		$F800+ST_helpMsg		;Calls ST_helpMsg with the new Line1111 Emulator Vector
	lea		4(a7),a7
	rts						;Quit
MemoryError:
	pea		Error(pc)			;Error of memory
	ROM_CALL	ST_helpMsg
	lea		4(a7),a7
	rts
Error	dc.b		"Not Enough Memory",0
Succes	dc.b		"Installation successful",0



	even						;To avoid "Address Error"
TSR_Start:

	movem.l	d0/a0-a1,-(a7)		;Save registers (useful?)
	move.l		14(a7),a0			;Gets the address of the last instruction of user program
	move.w		(a0),d0			;Gets the last instruction
	cmp.w		#$F800,d0			;Is it $F8xx?
	blt		OldOne				;No => use old Line1111 Emulator Vector
	addq.l		#2,a0				;Gets next instruction of user program
	move		usp,a1				;Gets the Stack of user program ( <=> a7 )
	move.l		a0,-(a1)			;Puts Return Address
	move		a1,usp				;Saves the Stack of user program

	and.w		#$7ff,d0			;Gets RomCall Number
	lsl.l		#2,d0				; * 4
	move.l		$C8,a0
	move.l		0(a0,d0),a0			; + ($C8)
	move.l		a0,14(a7)			;Puts ROM_CALL address for Return Exception
	movem.l	(a7)+,d0/a0-a1		;Restore Registers
	rte						;Quits Exception
;What the TI does next:
;rte sets usp in a7 and jumps to the ROM_CALL
;at the end of ROM_CALL, the "rts" jumps to the following of the program


OldOne:
	movem.l	(a7)+,d0/a0-a1		;Restore Registers
	lea		Old1111(pc),a0
	jmp		(a0)				;Jump to the old Line1111 Emulator Vector
Old1111		dc.l    0


TSR_End:

;*****************************************************

	end
